function  [y,motionveccc,abayerwhich]=colorvideosimulatorprfunc(data,paramvideo,blurkernel,handlesdistribtext);
%Writen by  by Sina Farsiu Feb4 2004
%It downsamples blures and demosaics a color image and prouces a set of LR blury
%nosiy demosaiced(bayer) frames (or non demosaiced)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%paramvideo
res=paramvideo(1);
motionspeed=paramvideo(2);
outwidth=paramvideo(3);
outheight=paramvideo(4);
numout=paramvideo(5);
snrout=paramvideo(6);
ifrandom=paramvideo(7);
ifhandmotion=paramvideo(8);
ifrandbayer=paramvideo(9);
ifdemos=paramvideo(10);
kernel=blurkernel;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
z=size(data);
handles.distribtext=handlesdistribtext;
hroutheight=outheight*res;%height of the the HR frame
hroutwidth=outwidth*res;%width of the the HR frame

for k=1:3
    blureddata(:,:,k)=sinablur(data(:,:,k),blurkernel,'same');
end




if ~ifhandmotion%if the motion is not picked by hand
    
    horizonmotion=0;
    lrvideo=zeros(outheight,outwidth,3,numout);%will keep the low-res sequence
    motionvec=zeros(2,numout-1);
    hm = waitbar(0,'Please wait for downsampling process');
    %hroutwidth
    for i=1:numout
        waitbar(i/numout)
        %i
        % hroutwidth+horizonmotion+motionspeed*res;
        if i~=1
            for k=1:3
                a(:,:,k)=blureddata(1:hroutheight,1+horizonmotion+motionspeed*res:hroutwidth+horizonmotion+motionspeed*res,k);
            end
        else
            for k=1:3
                a(:,:,k)=blureddata(1:hroutheight,1:hroutwidth,k);
            end
        end
        if ~ifrandom
            t=mod(fix(i/res),res);
            for k=1:3
                b(:,:,k)=a(1+t:res:hroutheight,1:res:hroutwidth,k);
            end
        else
            if i~=1
                t= randint(1,1,res);
            else
                t=0;
            end
            for k=1:3
                b(:,:,k)=a(1+t:res:hroutheight,1:res:hroutwidth,k);
            end
        end
        
        
        vari=var(b(:));%computing the variance of the original image
        deltan=vari/(10^(snrout/10));%snr=10log(delta/deltan) in which deltan is the variance of original frame, (Nhat thesis page 108)
        for k=1:3
            lrvideo(:,:,k,i)=b(:,:,k)+sqrt(deltan)*(randn(size(b(:,:,k))));%We add noise to make low resolution frames  noisy
        end
        if i~=1
            motionvec(:,i)=[t;horizonmotion+motionspeed*res];
            horizonmotion=1+horizonmotion+motionspeed*res;
        else
            motionvec(:,i)=[0;0];
            horizonmotion=1;
        end
        
        
    end
    close(hm)
    zz=[outheight,outwidth,numout];
    
    motionvecc(1,:)=(-1)*motionvec(2,:)./res;
    motionvecc(2,:)=(-1)*motionvec(1,:)./res;
    %motionvecc(:,2:numout)
    motionveccc=motionvecc(:,2:numout);
    [motionvector lowresdist ]=distriblow2(motionvecc(:,2:numout),res,zz,handles.distribtext);
else%if the motion is  picked by hand
    figure
    imagesc(data/max(data(:)))
    title('Click on the position of the topleft corner of each LR frame')
    axis image
    colormap(gray)
    [xclick,yclick] = ginput(numout);
    close
    xclick=round(xclick);
    yclick=round(yclick);
    % [xclick,yclick] =round([xclick,yclick]);
    clicksize=size(xclick);
    numout=clicksize(1);%new numberr of output frames
    lrvideo=zeros(outheight,outwidth,3,numout);%will keep the low-res sequence
    motionvec=zeros(2,numout-1);%will keep the motion vectors
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %numout
    for i=1:numout
        %   i
        
        if yclick(i)+hroutheight-1>z(1)
            yclick(i)=z(1)-hroutheight+1;
        end
        if xclick(i)+hroutwidth-1>z(2)
            xclick(i)=z(2)-hroutwidth+1;
        end
        for k=1:3
            b(:,:,k)=blureddata(yclick(i):res:yclick(i)+hroutheight-1,xclick(i):res:xclick(i)+hroutwidth-1,k);%downsampled image
            vari=var(b(:));%computing the variance of the original image
            deltan=vari/(10^(snrout/10));%snr=10log(delta/deltan) in which deltan is the variance of original frame, (Nhat thesis page 108)
            lrvideo(:,:,k,i)=b(:,:,k)+sqrt(deltan)*(randn(size(b(:,:,k))));%We add noise to make low resolution frames  noisy
        end
        
        
        if i==1
            
        else
            
            motionvec(:,i-1)=[yclick(i)-yclick(1);xclick(i)-xclick(1)];
            
        end
    end
    motionvecc(1,:)=(-1)*motionvec(2,:)./res;
    motionvecc(2,:)=(-1)*motionvec(1,:)./res;
    
    motionveccc=motionvecc;
    
    
    
    
    zz=[outheight,outwidth,numout];
    [motionvector lowresdist ]=distriblow2(motionvec,res,zz,handles.distribtext);
    
%     for i=2:numout-1
%     motionveccc(:,i)=motionveccc(:,i-1)+motionveccc(:,i);
%     end
%     
    
end


%Bayer sampling with random begining point 

if ifdemos
    a=lrvideo;
for i=1:numout
    if ifrandbayer %making random bayer
    whichbayer=randint(1,1,4)+1;
    else%non-random bayer
        op=floor((i-1)/res)+1;
        oq=mod(i-1,res)+1;
        if (mod(op,2)~=0 & mod(oq,2)~=0)
            whichbayer=1;
        elseif (mod(op,2)~=0 & mod(oq,2)==0)
            whichbayer=2;
        elseif (mod(op,2)==0 & mod(oq,2)~=0)
            whichbayer=3;
        elseif (mod(op,2)==0 & mod(oq,2)==0)
            whichbayer=4;
        end
        
            

    end
    if whichbayer==1
        abayer(:,:,i)=bayermaker(a(:,:,:,i));
        abayerwhich(i)=1;
    elseif whichbayer==2
        abayer(:,:,i)=bayermaker2(a(:,:,:,i));
        abayerwhich(i)=2;
    elseif whichbayer==3
        abayer(:,:,i)=bayermaker3(a(:,:,:,i));
        abayerwhich(i)=3;
    elseif whichbayer==4
        abayer(:,:,i)=bayermaker4(a(:,:,:,i));
        abayerwhich(i)=4;
    end
    
end

size(lrvideo);
y=abayer;
else%no bayer
    abayerwhich=1;
    y=lrvideo;
end

