function  [lrvideo,motionveccc]=videosimulatorprfunc(data,paramvideo,blurkernel,handlesdistribtext);
%Writen by  by Sina Farsiu Nov 22 2003

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%paramvideo
res=paramvideo(1);
motionspeed=paramvideo(2);
outwidth=paramvideo(3);
outheight=paramvideo(4);
numout=paramvideo(5);
snrout=paramvideo(6);
ifrandom=paramvideo(7);
ifhandmotion=paramvideo(8);
kernel=blurkernel;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
z=size(data);
handles.distribtext=handlesdistribtext;
hroutheight=outheight*res;%height of the the HR frame
hroutwidth=outwidth*res;%width of the the HR frame
blureddata=sinablur(data,blurkernel,'same');




if ~ifhandmotion%if the motion is not picked by hand
    
    horizonmotion=0;
    lrvideo=zeros(outheight,outwidth,numout);%will keep the low-res sequence
    motionvec=zeros(2,numout-1);
    hm = waitbar(0,'Please wait for downsampling process');
    %hroutwidth
    for i=1:numout
        waitbar(i/numout)
        %i
        % hroutwidth+horizonmotion+motionspeed*res;
        if i~=1
            a=blureddata(1:hroutheight,1+horizonmotion+motionspeed*res:hroutwidth+horizonmotion+motionspeed*res);
        else
            a=blureddata(1:hroutheight,1:hroutwidth);
        end
        if ~ifrandom
            t=mod(fix(i/res),res);
            b=a(1+t:res:hroutheight,1:res:hroutwidth);
        else
            if i~=1
                t= randint(1,1,res);
            else
                t=0;
            end
            b=a(1+t:res:hroutheight,1:res:hroutwidth);
        end
        
        
        vari=var(b(:));%c
        deltan=vari/(10^(snrout/10));%sn
        lrvideo(:,:,i)=b+sqrt(deltan)*(randn(size(b)));%We ad
        if i~=1
            motionvec(:,i)=[t;horizonmotion+motionspeed*res];
            horizonmotion=1+horizonmotion+motionspeed*res;
        else
            motionvec(:,i)=[0;0];
            horizonmotion=1;
        end
        
        
    end
    close(hm)
    zz=[outheight,outwidth,numout];
    
    motionvecc(1,:)=(-1)*motionvec(2,:)./res;
    motionvecc(2,:)=(-1)*motionvec(1,:)./res;
    %motionvecc(:,2:numout)
    motionveccc=motionvecc(:,2:numout);
    [motionvector lowresdist ]=distriblow2(motionvecc(:,2:numout),res,zz,handles.distribtext);
else%i
    figure
    imagesc(data)
    title('Click on the position of the topleft corner of each LR frame')
    axis image
    colormap(gray)
    [xclick,yclick] = ginput(numout);
    close
    xclick=round(xclick);
    yclick=round(yclick);
    % [xclick,yclick] =round([xclick,yclick]);
    clicksize=size(xclick);
    numout=clicksize(1);%new 
    lrvideo=zeros(outheight,outwidth,numout);%w
    motionvec=zeros(2,numout-1);%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %numout
    for i=1:numout
     %   i
        
        if yclick(i)+hroutheight-1>z(1)
            yclick(i)=z(1)-hroutheight+1;
        end
        if xclick(i)+hroutwidth-1>z(2)
            xclick(i)=z(2)-hroutwidth+1;
        end
        
        b=blureddata(yclick(i):res:yclick(i)+hroutheight-1,xclick(i):res:xclick(i)+hroutwidth-1);%d
        vari=var(b(:));%
        deltan=vari/(10^(snrout/10));%s
        lrvideo(:,:,i)=b+sqrt(deltan)*(randn(size(b)));%We
        
        
        
        if i==1
            
        else
            
            motionvec(:,i-1)=[yclick(i)-yclick(1);xclick(i)-xclick(1)];
            
        end
    end
    motionvec(1,:)=(-1)*motionvec(2,:)./res;
    motionvec(2,:)=(-1)*motionvec(1,:)./res;
    
    motionveccc=motionvec;
    zz=[outheight,outwidth,numout];
    [motionvector lowresdist ]=distriblow2(motionvec,res,zz,handles.distribtext);
end
